Index: src/Patterns/Singleton_impl.hpp
===================================================================
--- src/Patterns/Singleton_impl.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Patterns/Singleton_impl.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,142 @@
+/*
+ * Singleton_impl.hpp
+ *
+ *  Created on: Mar 10, 2010
+ *      Author: crueger
+ */
+
+#ifndef SINGLETON_IMPL_HPP_
+#define SINGLETON_IMPL_HPP_
+
+#include "Patterns/Singleton.hpp"
+
+/****** Static instance Variables of the template *******/
+
+template <class T,bool _may_create>
+typename Singleton<T,_may_create>::ptr_t Singleton<T,_may_create>::theInstance(0);
+
+template <class T,bool _may_create>
+boost::recursive_mutex Singleton<T,_may_create>::instanceLock;
+
+/****** templates singleton creation and destruction functions ******/
+
+template <class T,bool _may_create>
+T& Singleton<T,_may_create>::getInstance(){
+  // boost supports RAII-Style locking, so we don't need to unlock
+  boost::recursive_mutex::scoped_lock guard(instanceLock);
+  if(!theInstance.get()) {
+    theInstance.reset(creator::make());
+  }
+  return *theInstance;
+}
+
+template <class T,bool _may_create>
+T* Singleton<T,_may_create>::getPointer(){
+  // boost supports RAII-Style locking, so we don't need to unlock
+  boost::recursive_mutex::scoped_lock guard(instanceLock);
+  if(!theInstance.get()) {
+    theInstance.reset(creator::make());
+  }
+  return theInstance.get();
+
+}
+
+template <class T,bool _may_create>
+void Singleton<T,_may_create>::purgeInstance(){
+  // boost supports RAII-Style locking, so we don't need to unlock
+  boost::recursive_mutex::scoped_lock guard(instanceLock);
+  theInstance.reset();
+}
+
+template <class T,bool _may_create>
+T& Singleton<T,_may_create>::resetInstance(){
+  ptr_t oldInstance;
+  {
+    // boost supports RAII-Style locking, so we don't need to unlock
+    boost::recursive_mutex::scoped_lock guard(instanceLock);
+
+    oldInstance = theInstance;
+    theInstance.reset(creator::make());
+    // oldworld does not need protection any more,
+    // since we should have the only reference
+
+    // worldLock handles access to the pointer,
+    // not to the object
+  } // scope-end releases the lock
+
+  // oldInstance goes out of scope at the End of this function. The carried object will then be destroyed by the auto_ptr
+  return *theInstance;
+}
+
+
+template <class T,bool _may_create>
+void Singleton<T,_may_create>::setInstance(T* newInstance){
+  assert(!theInstance.get() && "Trying to set the instance of an already created singleton");
+  boost::recursive_mutex::scoped_lock guard(instanceLock);
+  theInstance.reset(newInstance);
+}
+
+template<class T, bool _may_create>
+Singleton<T,_may_create>::Singleton(){/* empty */}
+
+// private copy constructor to avoid unintended copying
+template <class T, bool _may_create>
+Singleton<T,_may_create>::Singleton(const Singleton<T,_may_create>&){
+  assert(0 && "Copy constructor of singleton template called");
+}
+
+/**
+ * This define allows simple instantiation of the necessary singleton functions
+ * at a chosen place.
+ */
+#define CONSTRUCT_SINGLETON(name) \
+    template name& Singleton< name , name::may_create >::getInstance(); \
+    template name* Singleton< name , name::may_create >::getPointer();  \
+    template void  Singleton< name , name::may_create >::purgeInstance(); \
+    template name& Singleton< name , name::may_create >::resetInstance(); \
+    template void  Singleton< name , name::may_create >::setInstance( name* );
+
+/************ Internal Pointer Wrapper to allow automatic purging *************/
+
+template <class T,bool _may_create>
+Singleton<T,_may_create>::ptr_t::ptr_t() :
+content(0){};
+
+template <class T,bool _may_create>
+Singleton<T,_may_create>::ptr_t::ptr_t(T* _content) :
+content(_content){};
+
+template <class T,bool _may_create>
+Singleton<T,_may_create>::ptr_t:: ~ptr_t()
+{delete content;};
+
+template <class T,bool _may_create>
+T& Singleton<T,_may_create>::ptr_t::operator*()
+{return *content;};
+
+template <class T,bool _may_create>
+T* Singleton<T,_may_create>::ptr_t::get()
+{return content;};
+
+template <class T,bool _may_create>
+void Singleton<T,_may_create>::ptr_t::reset(T* _content){
+  delete content;
+  content = _content;
+}
+
+template <class T,bool _may_create>
+void Singleton<T,_may_create>::ptr_t::reset()
+{reset(0);}
+
+template <class T,bool _may_create>
+typename Singleton<T,_may_create>::ptr_t& Singleton<T,_may_create>::ptr_t::operator=(const typename Singleton<T,_may_create>::ptr_t& rhs){
+  if(&rhs!=this){
+    delete content;
+    content = rhs.content;
+    rhs.content = 0;
+  }
+  return *this;
+}
+
+
+#endif /* SINGLETON_IMPL_HPP_ */
Index: src/Plane.cpp
===================================================================
--- src/Plane.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Plane.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,198 @@
+/*
+ * Plane.cpp
+ *
+ *  Created on: Apr 7, 2010
+ *      Author: crueger
+ */
+
+#include "Plane.hpp"
+#include "vector.hpp"
+#include "defs.hpp"
+#include "info.hpp"
+#include "log.hpp"
+#include "verbose.hpp"
+#include "Helpers/Assert.hpp"
+#include <cmath>
+
+/**
+ * generates a plane from three given vectors defining three points in space
+ */
+Plane::Plane(const Vector &y1, const Vector &y2, const Vector &y3) throw(LinearDependenceException) :
+  normalVector(new Vector())
+{
+  Vector x1 = y1 -y2;
+  Vector x2 = y3 -y2;
+  if ((fabs(x1.Norm()) < MYEPSILON) || (fabs(x2.Norm()) < MYEPSILON) || (fabs(x1.Angle(x2)) < MYEPSILON)) {
+    throw LinearDependenceException(__FILE__,__LINE__);
+  }
+//  Log() << Verbose(4) << "relative, first plane coordinates:";
+//  x1.Output((ofstream *)&cout);
+//  Log() << Verbose(0) << endl;
+//  Log() << Verbose(4) << "second plane coordinates:";
+//  x2.Output((ofstream *)&cout);
+//  Log() << Verbose(0) << endl;
+
+  normalVector->at(0) = (x1[1]*x2[2] - x1[2]*x2[1]);
+  normalVector->at(1) = (x1[2]*x2[0] - x1[0]*x2[2]);
+  normalVector->at(2) = (x1[0]*x2[1] - x1[1]*x2[0]);
+  normalVector->Normalize();
+
+  offset=normalVector->ScalarProduct(y1);
+}
+/**
+ * Constructs a plane from two direction vectors and a offset.
+ * If no offset is given a plane through origin is assumed
+ */
+Plane::Plane(const Vector &y1, const Vector &y2, double _offset) throw(ZeroVectorException,LinearDependenceException) :
+    normalVector(new Vector()),
+    offset(_offset)
+{
+  Vector x1 = y1;
+  Vector x2 = y2;
+  if ((fabs(x1.Norm()) < MYEPSILON) || (fabs(x2.Norm()) < MYEPSILON)) {
+    throw ZeroVectorException(__FILE__,__LINE__);
+  }
+
+  if((fabs(x1.Angle(x2)) < MYEPSILON)) {
+    throw LinearDependenceException(__FILE__,__LINE__);
+  }
+//  Log() << Verbose(4) << "relative, first plane coordinates:";
+//  x1.Output((ofstream *)&cout);
+//  Log() << Verbose(0) << endl;
+//  Log() << Verbose(4) << "second plane coordinates:";
+//  x2.Output((ofstream *)&cout);
+//  Log() << Verbose(0) << endl;
+
+  normalVector->at(0) = (x1[1]*x2[2] - x1[2]*x2[1]);
+  normalVector->at(1) = (x1[2]*x2[0] - x1[0]*x2[2]);
+  normalVector->at(2) = (x1[0]*x2[1] - x1[1]*x2[0]);
+  normalVector->Normalize();
+}
+
+Plane::Plane(const Vector &_normalVector, double _offset) throw(ZeroVectorException):
+  normalVector(new Vector(_normalVector)),
+  offset(_offset)
+{
+  if(normalVector->IsZero())
+    throw ZeroVectorException(__FILE__,__LINE__);
+  double factor = 1/normalVector->Norm();
+  // normalize the plane parameters
+  (*normalVector)*=factor;
+  offset*=factor;
+}
+
+Plane::Plane(const Vector &_normalVector, const Vector &_offsetVector) throw(ZeroVectorException):
+    normalVector(new Vector(_normalVector))
+{
+  if(normalVector->IsZero()){
+    throw ZeroVectorException(__FILE__,__LINE__);
+  }
+  normalVector->Normalize();
+  offset = normalVector->ScalarProduct(_offsetVector);
+}
+
+Plane::~Plane()
+{}
+
+
+Vector Plane::getNormal() const{
+  return *normalVector;
+}
+
+double Plane::getOffset() const{
+  return offset;
+}
+
+Vector Plane::getOffsetVector() {
+  return getOffset()*getNormal();
+}
+
+vector<Vector> Plane::getPointsOnPlane(){
+  std::vector<Vector> res;
+  res.reserve(3);
+  // first point on the plane
+  res.push_back(getOffsetVector());
+  // get a vector that has direction of plane
+  Vector direction;
+  direction.GetOneNormalVector(getNormal());
+  res.push_back(res[0]+direction);
+  // get an orthogonal vector to direction and normal (has direction of plane)
+  direction.VectorProduct(getNormal());
+  direction.Normalize();
+  res.push_back(res[0] +direction);
+  return res;
+}
+
+
+/** Calculates the intersection point between a line defined by \a *LineVector and \a *LineVector2 and a plane defined by \a *Normal and \a *PlaneOffset.
+ * According to [Bronstein] the vectorial plane equation is:
+ *   -# \f$\stackrel{r}{\rightarrow} \cdot \stackrel{N}{\rightarrow} + D = 0\f$,
+ * where \f$\stackrel{r}{\rightarrow}\f$ is the vector to be testet, \f$\stackrel{N}{\rightarrow}\f$ is the plane's normal vector and
+ * \f$D = - \stackrel{a}{\rightarrow} \stackrel{N}{\rightarrow}\f$, the offset with respect to origin, if \f$\stackrel{a}{\rightarrow}\f$,
+ * is an offset vector onto the plane. The line is parametrized by \f$\stackrel{x}{\rightarrow} + k \stackrel{t}{\rightarrow}\f$, where
+ * \f$\stackrel{x}{\rightarrow}\f$ is the offset and \f$\stackrel{t}{\rightarrow}\f$ the directional vector (NOTE: No need to normalize
+ * the latter). Inserting the parametrized form into the plane equation and solving for \f$k\f$, which we insert then into the parametrization
+ * of the line yields the intersection point on the plane.
+ * \param *Origin first vector of line
+ * \param *LineVector second vector of line
+ * \return true -  \a this contains intersection point on return, false - line is parallel to plane (even if in-plane)
+ */
+Vector Plane::GetIntersection(const Vector &Origin, const Vector &LineVector)
+{
+  Info FunctionInfo(__func__);
+  Vector res;
+
+  // find intersection of a line defined by Offset and Direction with a  plane defined by triangle
+  Vector Direction = LineVector - Origin;
+  Direction.Normalize();
+  Log() << Verbose(1) << "INFO: Direction is " << Direction << "." << endl;
+  //Log() << Verbose(1) << "INFO: PlaneNormal is " << *PlaneNormal << " and PlaneOffset is " << *PlaneOffset << "." << endl;
+  double factor1 = Direction.ScalarProduct(*normalVector.get());
+  if (fabs(factor1) < MYEPSILON) { // Uniqueness: line parallel to plane?
+    Log() << Verbose(1) << "BAD: Line is parallel to plane, no intersection." << endl;
+    throw LinearDependenceException(__FILE__,__LINE__);
+  }
+
+  double factor2 = Origin.ScalarProduct(*normalVector.get());
+  if (fabs(factor2-offset) < MYEPSILON) { // Origin is in-plane
+    Log() << Verbose(1) << "GOOD: Origin of line is in-plane." << endl;
+    res = Origin;
+    return res;
+  }
+
+  double scaleFactor = (offset-factor2)/factor1;
+
+  //factor = Origin->ScalarProduct(PlaneNormal)*(-PlaneOffset->ScalarProduct(PlaneNormal))/(Direction.ScalarProduct(PlaneNormal));
+  Direction.Scale(scaleFactor);
+  res = Origin + Direction;
+  Log() << Verbose(1) << "INFO: Scaled direction is " << Direction << "." << endl;
+
+  // test whether resulting vector really is on plane
+  ASSERT(fabs(res.ScalarProduct(*normalVector) - offset) < MYEPSILON,
+         "Calculated line-Plane intersection does not lie on plane.");
+  return res;
+};
+
+/************ Methods inherited from Space ****************/
+
+double Plane::distance(const Vector &point) const{
+  double res = point.ScalarProduct(*normalVector)-offset;
+  return fabs(res);
+}
+
+Vector Plane::getClosestPoint(const Vector &point) const{
+  double factor = point.ScalarProduct(*normalVector)-offset;
+  if(fabs(factor) < MYEPSILON){
+    // the point itself lies on the plane
+    return point;
+  }
+  Vector difference = factor * (*normalVector);
+  return (point - difference);
+}
+
+// Operators
+
+ostream &operator << (ostream &ost,const Plane &p){
+  ost << "<" << p.getNormal() << ";x> - " << p.getOffset() << "=0";
+  return ost;
+}
Index: src/Plane.hpp
===================================================================
--- src/Plane.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Plane.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,65 @@
+/*
+ * Plane.hpp
+ *
+ *  Created on: Apr 7, 2010
+ *      Author: crueger
+ */
+
+#ifndef PLANE_HPP_
+#define PLANE_HPP_
+
+#include <memory>
+#include <vector>
+#include <iostream>
+#include "Space.hpp"
+#include "Exceptions/LinearDependenceException.hpp"
+#include "Exceptions/ZeroVectorException.hpp"
+
+class Vector;
+
+class Plane : public Space
+{
+  typedef std::auto_ptr<Vector> vec_ptr;
+public:
+  Plane(const Vector &y1, const Vector &y2, const Vector &y3) throw(LinearDependenceException);
+  Plane(const Vector &y1, const Vector &y2, double _offset) throw(ZeroVectorException,LinearDependenceException);
+  Plane(const Vector &_normalVector, double _offset)  throw(ZeroVectorException);
+  Plane(const Vector &_normalVector, const Vector &_offsetVector) throw(ZeroVectorException);
+  virtual ~Plane();
+
+  // Accessor Functions
+  /**
+   * returns normal Vector for a plane
+   */
+  Vector getNormal() const;
+  /**
+   * returns the distance of the plane from the origin
+   */
+  double getOffset() const;
+  /**
+   * returns a vector that points on the plane.
+   * Same as getOffset()*getNormal();
+   */
+  Vector getOffsetVector();
+
+  /**
+   * returns three seperate points on this plane
+   */
+  std::vector<Vector> getPointsOnPlane();
+
+  // some calculations
+  Vector GetIntersection(const Vector &Origin, const Vector &LineVector);
+
+  /****** Methods inherited from Space ***********/
+
+  virtual double distance(const Vector &point) const;
+  virtual Vector getClosestPoint(const Vector &point) const;
+
+private:
+  vec_ptr normalVector;
+  double offset;
+};
+
+std::ostream &operator<< (std::ostream &ost,const Plane& p);
+
+#endif /* PLANE_HPP_ */
Index: src/Space.cpp
===================================================================
--- src/Space.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Space.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,23 @@
+/*
+ * Space.cpp
+ *
+ *  Created on: Apr 30, 2010
+ *      Author: crueger
+ */
+
+#include "Space.hpp"
+#include "vector.hpp"
+
+Space::Space()
+{}
+
+Space::~Space()
+{}
+
+bool Space::hasZero() const{
+  return isContained(zeroVec);
+}
+
+bool Space::isContained(const Vector &point) const{
+  return (distance(point)) < MYEPSILON;
+}
Index: src/Space.hpp
===================================================================
--- src/Space.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Space.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,26 @@
+/*
+ * Space.hpp
+ *
+ *  Created on: Apr 30, 2010
+ *      Author: crueger
+ */
+
+#ifndef SPACE_HPP_
+#define SPACE_HPP_
+
+class Vector;
+
+class Space
+{
+public:
+  Space();
+  virtual ~Space();
+
+  virtual double distance(const Vector &point) const=0;
+  virtual Vector getClosestPoint(const Vector &point) const=0;
+  virtual bool isContained(const Vector &point) const;
+  virtual bool hasZero() const;
+
+};
+
+#endif /* SPACE_HPP_ */
Index: src/UIElements/CommandLineDialog.cpp
===================================================================
--- src/UIElements/CommandLineDialog.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/UIElements/CommandLineDialog.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,172 @@
+/*
+ * CommandLineDialog.cpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+
+#include <cassert>
+#include <iostream>
+
+#include <Descriptors/MoleculeDescriptor.hpp>
+#include <Descriptors/MoleculeIdDescriptor.hpp>
+#include "UIElements/CommandLineDialog.hpp"
+
+#include "periodentafel.hpp"
+#include "atom.hpp"
+#include "CommandLineParser.hpp"
+#include "defs.hpp"
+#include "molecule.hpp"
+#include "log.hpp"
+#include "verbose.hpp"
+#include "World.hpp"
+
+using namespace std;
+
+
+CommandLineDialog::CommandLineDialog()
+{
+}
+
+CommandLineDialog::~CommandLineDialog()
+{
+}
+
+
+void CommandLineDialog::queryEmpty(const char* title, string _description){
+  registerQuery(new EmptyCommandLineQuery(title, _description));
+}
+
+void CommandLineDialog::queryInt(const char* title, int* target, string _description){
+  registerQuery(new IntCommandLineQuery(title,target, _description));
+}
+
+void CommandLineDialog::queryDouble(const char* title, double* target, string _description){
+  registerQuery(new DoubleCommandLineQuery(title,target, _description));
+}
+
+void CommandLineDialog::queryString(const char* title, string* target, string _description){
+  registerQuery(new StringCommandLineQuery(title,target, _description));
+}
+
+void CommandLineDialog::queryMolecule(const char* title, molecule **target, MoleculeListClass *molecules, string _description) {
+  registerQuery(new MoleculeCommandLineQuery(title,target,molecules, _description));
+}
+
+void CommandLineDialog::queryVector(const char* title, Vector *target,const double *const cellSize, bool check, string _description) {
+  registerQuery(new VectorCommandLineQuery(title,target,cellSize,check, _description));
+}
+
+void CommandLineDialog::queryElement(const char* title, const element **target, string _description){
+  registerQuery(new ElementCommandLineQuery(title,target, _description));
+}
+
+/************************** Query Infrastructure ************************/
+
+CommandLineDialog::EmptyCommandLineQuery::EmptyCommandLineQuery(string title, string _description) :
+    Dialog::EmptyQuery(title, _description)
+{}
+
+CommandLineDialog::EmptyCommandLineQuery::~EmptyCommandLineQuery() {}
+
+bool CommandLineDialog::EmptyCommandLineQuery::handle() {
+  cout << "Message of " << getTitle() << ":\n" << getDescription() << "\n";
+  return true;
+}
+
+CommandLineDialog::IntCommandLineQuery::IntCommandLineQuery(string title,int *_target, string _description) :
+    Dialog::IntQuery(title,_target, _description)
+{}
+
+CommandLineDialog::IntCommandLineQuery::~IntCommandLineQuery() {}
+
+bool CommandLineDialog::IntCommandLineQuery::handle() {
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    tmp = CommandLineParser::getInstance().vm[getTitle()].as<int>();
+    return true;
+  } else
+    return false;
+}
+
+CommandLineDialog::StringCommandLineQuery::StringCommandLineQuery(string title,string *_target, string _description) :
+    Dialog::StringQuery(title,_target, _description)
+{}
+
+CommandLineDialog::StringCommandLineQuery::~StringCommandLineQuery() {}
+
+bool CommandLineDialog::StringCommandLineQuery::handle() {
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    tmp = CommandLineParser::getInstance().vm[getTitle()].as<string>();
+    return true;
+  } else
+    return false;
+}
+
+CommandLineDialog::DoubleCommandLineQuery::DoubleCommandLineQuery(string title,double *_target, string _description) :
+    Dialog::DoubleQuery(title,_target, _description)
+{}
+
+CommandLineDialog::DoubleCommandLineQuery::~DoubleCommandLineQuery() {}
+
+bool CommandLineDialog::DoubleCommandLineQuery::handle() {
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    tmp = CommandLineParser::getInstance().vm[getTitle()].as<double>();
+    return true;
+  } else
+    return false;
+}
+
+CommandLineDialog::MoleculeCommandLineQuery::MoleculeCommandLineQuery(string title, molecule **_target, MoleculeListClass *_molecules, string _description) :
+    Dialog::MoleculeQuery(title,_target,_molecules, _description)
+{}
+
+CommandLineDialog::MoleculeCommandLineQuery::~MoleculeCommandLineQuery() {}
+
+bool CommandLineDialog::MoleculeCommandLineQuery::handle() {
+  int IdxOfMol = -1;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    IdxOfMol = CommandLineParser::getInstance().vm[getTitle()].as<int>();
+    tmp = World::getInstance().getMolecule(MoleculeById(IdxOfMol));
+    return true;
+  } else
+    return false;
+}
+
+CommandLineDialog::VectorCommandLineQuery::VectorCommandLineQuery(string title, Vector *_target, const double *const _cellSize, bool _check, string _description) :
+    Dialog::VectorQuery(title,_target,_cellSize,_check, _description)
+{}
+
+CommandLineDialog::VectorCommandLineQuery::~VectorCommandLineQuery()
+{}
+
+bool CommandLineDialog::VectorCommandLineQuery::handle() {
+  vector<double> temp;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    temp = CommandLineParser::getInstance().vm[getTitle()].as<vector<double> >();
+    assert((temp.size() == 3) && "Vector from command line does not have three components.");
+    tmp = new Vector;
+    for (int i=0;i<NDIM;i++)
+      tmp->at(i) = temp[i];
+    return true;
+  } else
+    return false;
+}
+
+
+CommandLineDialog::ElementCommandLineQuery::ElementCommandLineQuery(string title, const element **target, string _description) :
+    Dialog::ElementQuery(title,target, _description)
+{}
+
+CommandLineDialog::ElementCommandLineQuery::~ElementCommandLineQuery()
+{}
+
+bool CommandLineDialog::ElementCommandLineQuery::handle() {
+  int Z = -1;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    Z = CommandLineParser::getInstance().vm[getTitle()].as<int>();
+    tmp = World::getInstance().getPeriode()->FindElement(Z);
+    return true;
+  } else
+    return false;
+}
Index: src/UIElements/CommandLineDialog.hpp
===================================================================
--- src/UIElements/CommandLineDialog.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/UIElements/CommandLineDialog.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,84 @@
+/*
+ * CommandLineDialog.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef COMMANDLINEDIALOG_HPP_
+#define COMMANDLINEDIALOG_HPP_
+
+#include <string>
+
+#include "UIElements/Dialog.hpp"
+
+/** CommandLineUIFactory implementation of the Dialog.
+ * The idea here is that for each query the parsed command line options are used instead.
+ */
+class CommandLineDialog : public Dialog
+{
+public:
+  CommandLineDialog();
+  virtual ~CommandLineDialog();
+
+  virtual void queryEmpty(const char *, std::string = "");
+  virtual void queryInt(const char *, int *, std::string = "");
+  virtual void queryString(const char*, std::string *, std::string = "");
+  virtual void queryDouble(const char*, double*, std::string = "");
+  virtual void queryMolecule(const char*,molecule**,MoleculeListClass*, std::string = "");
+  virtual void queryVector(const char*,Vector *,const double * const,bool, std::string = "");
+  virtual void queryElement(const char*,const element **, std::string = "");
+
+protected:
+  // specialized stuff for text queries
+  class EmptyCommandLineQuery : public Dialog::EmptyQuery {
+  public:
+    EmptyCommandLineQuery(std::string title, std::string _description = "");
+    virtual ~EmptyCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class IntCommandLineQuery : public Dialog::IntQuery {
+  public:
+    IntCommandLineQuery(std::string title, int *_target, std::string _description = "");
+    virtual ~IntCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class DoubleCommandLineQuery : public Dialog::DoubleQuery {
+  public:
+    DoubleCommandLineQuery(std::string title, double *_target, std::string _description = "");
+    virtual ~DoubleCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class StringCommandLineQuery : public Dialog::StringQuery {
+  public:
+    StringCommandLineQuery(std::string title, std::string *_target, std::string _description = "");
+    virtual ~StringCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class MoleculeCommandLineQuery : public Dialog::MoleculeQuery {
+  public:
+    MoleculeCommandLineQuery(std::string title, molecule **_target, MoleculeListClass *_molecules, std::string _description = "");
+    virtual ~MoleculeCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class VectorCommandLineQuery : public Dialog::VectorQuery {
+  public:
+    VectorCommandLineQuery(std::string title,Vector *_target,const double *const _cellSize,bool _check, std::string _description = "");
+    virtual ~VectorCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class ElementCommandLineQuery : public Dialog::ElementQuery {
+  public:
+    ElementCommandLineQuery(std::string title, const element **_target, std::string _description = "");
+    virtual ~ElementCommandLineQuery();
+    virtual bool handle();
+  };
+};
+
+#endif /* COMMANDLINEDIALOG_HPP_ */
Index: src/UIElements/CommandLineStatusIndicator.cpp
===================================================================
--- src/UIElements/CommandLineStatusIndicator.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/UIElements/CommandLineStatusIndicator.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,57 @@
+/*
+ * CommandLineStatusIndicator.cpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+
+#include "CommandLineStatusIndicator.hpp"
+
+#include <iostream>
+
+#include "Actions/Process.hpp"
+
+using namespace std;
+
+CommandLineStatusIndicator::CommandLineStatusIndicator()
+{
+  Process::AddObserver(this);
+}
+
+CommandLineStatusIndicator::~CommandLineStatusIndicator()
+{
+  Process::RemoveObserver(this);
+}
+
+void CommandLineStatusIndicator::update(Observable *subject){
+  Process *proc;
+  // we are only observing Processes
+  if((proc=dynamic_cast<Process*>(subject))){
+    // see what kind of progress we have to display
+    if(proc->getMaxSteps()>0){
+      if(!proc->doesStop()){
+        cout << "Busy (" << proc->getName() << ") ";
+        // we can show a percentage done
+        cout << (int)proc->getDoneRatio() << "% done" << endl;
+      }
+    }
+    else{
+      // we only show some kind of busy animation
+      if(proc->doesStart()){
+        cout << "Busy (" << proc->getName() << ")";
+      }
+      if(!proc->doesStop()){
+        cout << ".";
+      }
+      else {
+        cout << endl;
+      }
+    }
+  }
+}
+
+void CommandLineStatusIndicator::subjectKilled(Observable *subject){
+
+}
+
Index: src/UIElements/CommandLineStatusIndicator.hpp
===================================================================
--- src/UIElements/CommandLineStatusIndicator.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/UIElements/CommandLineStatusIndicator.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,26 @@
+/*
+ * CommandLineStatusIndicator.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef COMMANDLINESTATUSINDICATOR_HPP_
+#define COMMANDLINESTATUSINDICATOR_HPP_
+
+#include "Patterns/Observer.hpp"
+
+class CommandLineStatusIndicator : public Observer
+{
+public:
+  CommandLineStatusIndicator();
+  virtual ~CommandLineStatusIndicator();
+
+  void update(Observable *subject);
+  void subjectKilled(Observable *subject);
+
+private:
+
+};
+
+#endif /* COMMANDLINESTATUSINDICATOR_HPP_ */
Index: src/UIElements/CommandLineUIFactory.hpp
===================================================================
--- src/UIElements/CommandLineUIFactory.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/UIElements/CommandLineUIFactory.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,28 @@
+/*
+ * CommandLineUIFactory.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef COMMANDLINEUIFACTORY_HPP_
+#define COMMANDLINEUIFACTORY_HPP_
+
+#include "UIElements/UIFactory.hpp"
+
+class CommandLineUIFactory : public UIFactory
+{
+friend class UIFactory;
+
+public:
+  virtual ~CommandLineUIFactory();
+
+  virtual Dialog* makeDialog();
+  virtual MainWindow* makeMainWindow();
+
+protected:
+  CommandLineUIFactory();
+};
+
+
+#endif /* COMMANDLINEUIFACTORY_HPP_ */
Index: src/UIElements/CommandLineWindow.cpp
===================================================================
--- src/UIElements/CommandLineWindow.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/UIElements/CommandLineWindow.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,81 @@
+/*
+ * CommandLineWindow.cpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#include <boost/bind.hpp>
+
+#include "UIElements/CommandLineWindow.hpp"
+#include "UIElements/CommandLineStatusIndicator.hpp"
+
+#include "Actions/ActionRegistry.hpp"
+#include "Actions/CmdAction/HelpAction.hpp"
+#include "Actions/CmdAction/VersionAction.hpp"
+#include "Actions/ParserAction/LoadXyzAction.hpp"
+#include "Actions/ParserAction/SaveXyzAction.hpp"
+#include "CommandLineParser.hpp"
+
+#include <iostream>
+
+using namespace std;
+
+// TODO: see what code can be moved to a base class for Graphic and CommandLine Windows
+CommandLineWindow::CommandLineWindow()
+{
+  // create and register all command line callable actions
+  populateAtomActions();
+  populateCmdActions();
+  populateFragmentationActions();
+  populateMoleculeActions();
+  populateParserActions();
+  populateTesselationActions();
+
+  // Add status indicators etc...
+  statusIndicator = new CommandLineStatusIndicator();
+}
+
+CommandLineWindow::~CommandLineWindow()
+{
+  delete statusIndicator;
+}
+
+void CommandLineWindow::display() {
+  // go through all possible actions
+  for(std::map<const std::string,Action*>::iterator ActionRunner = ActionRegistry::getInstance().getBeginIter(); ActionRunner != ActionRegistry::getInstance().getEndIter(); ActionRunner++) {
+    // check whether action is present in command line
+    if (CommandLineParser::getInstance().vm.count(ActionRunner->first)) {
+      ActionRunner->second->call();
+    }
+  }
+}
+
+void CommandLineWindow::populateAtomActions()
+{
+}
+
+void CommandLineWindow::populateCmdActions()
+{
+  new CommandLineHelpAction();
+  new CommandLineVersionAction();
+}
+
+void CommandLineWindow::populateFragmentationActions()
+{
+}
+
+void CommandLineWindow::populateMoleculeActions()
+{
+}
+
+void CommandLineWindow::populateParserActions()
+{
+  new ParserLoadXyzAction();
+  new ParserSaveXyzAction();
+}
+
+void CommandLineWindow::populateTesselationActions()
+{
+}
+
Index: src/UIElements/CommandLineWindow.hpp
===================================================================
--- src/UIElements/CommandLineWindow.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/UIElements/CommandLineWindow.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,36 @@
+/*
+ * CommandLineWindow.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef COMMANDLINEWINDOW_HPP_
+#define COMMANDLINEWINDOW_HPP_
+
+#include "UIElements/MainWindow.hpp"
+
+class CommandLineStatusIndicator;
+
+class CommandLineWindow : public MainWindow
+{
+public:
+  CommandLineWindow();
+  virtual ~CommandLineWindow();
+
+  virtual void display();
+
+private:
+  // populaters
+  void populateAtomActions();
+  void populateCmdActions();
+  void populateFragmentationActions();
+  void populateMoleculeActions();
+  void populateParserActions();
+  void populateTesselationActions();
+
+  CommandLineStatusIndicator *statusIndicator;
+
+};
+
+#endif /* COMMANDLINEWINDOW_HPP_ */
